# PDFlib PLOP DS:
# Encrypt file with certificate security.

from sys import *
from PDFlib.PLOP import *

# This is where input files live. Adjust as necessary.
searchpath = "../data"
plop = None

recipients_cert = [
    # no permission restrictions
    "../data/demo_recipient_1.pem",
    # form filling and signing permissions granted, but not others
    "../data/demo_recipient_2.pem",
    "../data/demo_recipient_3.pem"
]
recipients_perm = [
    # no permission restrictions
    "",
    # form filling and signing permissions granted, but not others
    "nomodify nocopy noannots noassemble",
    "nomodify nocopy noannots noassemble"
]
RECIPIENTCOUNT = len(recipients_cert)

if len(argv) != 3 :
    raise Exception("usage: certsec <infile> <outfile>" )

try:
    # create a new PLOP object
    plop = PLOP()

    optlist = "searchpath={%s}" % searchpath
    plop.set_option(optlist)

    # open unprotected input file
    doc = plop.open_document(argv[1], "")
    if (doc == -1):
        raise Exception("Error: %s" % plop.get_errmsg())

    # add recipients
    for r in range(0, RECIPIENTCOUNT, 1):
        optlist = "certificate={filename={%s}} permissions={%s}" % (recipients_cert[r], recipients_perm[r])
        if (plop.add_recipient(optlist) == -1):
            # emit warning and continue
            print("Error: %s\n" % plop.get_errmsg());

    # create protected output file
    optlist = "input={%d}" % doc
    if (plop.create_document(argv[2], optlist) == -1):
        raise Exception("Error: %s" % plop.get_errmsg())

    plop.close_document(doc, "")

except PLOPException as ex:
    print("PDFlib PLOP exception occurred:")
    print("[%d] %s: %s" % (ex.errnum, ex.apiname, ex.errmsg))

except Exception as ex:
    print(ex)

finally:
    if plop:
        plop.delete()
